// Class: haxe.macro.ExprTools

var $global = typeof window != "undefined" ? window : typeof global != "undefined" ? global : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = require("./../../hxClasses_stub").default;
var $import = require("./../../import_stub").default;
function haxe_macro_Printer() {return require("./../../haxe/macro/Printer");}
function Type() {return require("./../../Type");}
function haxe_macro_ExprArrayTools() {return require("./../../haxe/macro/ExprArrayTools");}
function haxe_macro_ExprDef() {return require("./../../haxe/macro/ExprDef");}
function Std() {return require("./../../Std");}
function js__$Boot_HaxeError() {return require("./../../js/_Boot/HaxeError");}
function Reflect() {return require("./../../Reflect");}

// Constructor

var ExprTools = function(){}

// Meta

ExprTools.__name__ = ["haxe","macro","ExprTools"];
ExprTools.prototype = {
	
};
ExprTools.prototype.__class__ = $hxClasses["haxe.macro.ExprTools"] = ExprTools;

// Init



// Statics

ExprTools.toString = function(e) {
	return new (haxe_macro_Printer().default)().printExpr(e);
}
ExprTools.iter = function(e,f) {
	var _g = e.expr;
	switch((Type().default).enumIndex(_g)) {
	case 1:
		var e2 = _g[3];
		var e1 = _g[2];
		f(e1);
		f(e2);
		break;
	case 2:
		var e21 = _g[4];
		var e11 = _g[3];
		f(e11);
		f(e21);
		break;
	case 3:
		var e3 = _g[2];
		f(e3);
		break;
	case 4:
		var e4 = _g[2];
		f(e4);
		break;
	case 5:
		var fl = _g[2];
		var _g1 = 0;
		while(_g1 < fl.length) {
			var fd = fl[_g1];
			++_g1;
			f(fd.expr);
		}
		break;
	case 6:
		var el = _g[2];
		(haxe_macro_ExprArrayTools().default).iter(el,f);
		break;
	case 7:
		var el1 = _g[3];
		var e5 = _g[2];
		f(e5);
		(haxe_macro_ExprArrayTools().default).iter(el1,f);
		break;
	case 8:
		var el2 = _g[3];
		(haxe_macro_ExprArrayTools().default).iter(el2,f);
		break;
	case 9:
		var e6 = _g[4];
		f(e6);
		break;
	case 10:
		var vl = _g[2];
		var _g2 = 0;
		while(_g2 < vl.length) {
			var v = vl[_g2];
			++_g2;
			ExprTools.opt2(v.expr,f);
		}
		break;
	case 11:
		var func = _g[3];
		var _g3 = 0;
		var _g11 = func.args;
		while(_g3 < _g11.length) {
			var arg = _g11[_g3];
			++_g3;
			ExprTools.opt2(arg.value,f);
		}
		ExprTools.opt2(func.expr,f);
		break;
	case 12:
		var el3 = _g[2];
		(haxe_macro_ExprArrayTools().default).iter(el3,f);
		break;
	case 13:
		var e22 = _g[3];
		var e12 = _g[2];
		f(e12);
		f(e22);
		break;
	case 14:
		var e23 = _g[3];
		var e13 = _g[2];
		f(e13);
		f(e23);
		break;
	case 15:
		var e31 = _g[4];
		var e24 = _g[3];
		var e14 = _g[2];
		f(e14);
		f(e24);
		ExprTools.opt2(e31,f);
		break;
	case 16:
		var e25 = _g[3];
		var e15 = _g[2];
		f(e15);
		f(e25);
		break;
	case 17:
		var edef = _g[4];
		var cl = _g[3];
		var e7 = _g[2];
		f(e7);
		var _g4 = 0;
		while(_g4 < cl.length) {
			var c = cl[_g4];
			++_g4;
			(haxe_macro_ExprArrayTools().default).iter(c.values,f);
			ExprTools.opt2(c.guard,f);
			ExprTools.opt2(c.expr,f);
		}
		if(edef != null && edef.expr != null) {
			f(edef);
		}
		break;
	case 18:
		var cl1 = _g[3];
		var e8 = _g[2];
		f(e8);
		var _g5 = 0;
		while(_g5 < cl1.length) {
			var c1 = cl1[_g5];
			++_g5;
			f(c1.expr);
		}
		break;
	case 19:
		var e9 = _g[2];
		ExprTools.opt2(e9,f);
		break;
	case 0:case 20:case 21:case 26:
		break;
	case 22:
		var e10 = _g[2];
		f(e10);
		break;
	case 23:
		var e16 = _g[2];
		f(e16);
		break;
	case 24:
		var e17 = _g[2];
		f(e17);
		break;
	case 25:
		var e18 = _g[2];
		f(e18);
		break;
	case 27:
		var e32 = _g[4];
		var e26 = _g[3];
		var e19 = _g[2];
		f(e19);
		f(e26);
		ExprTools.opt2(e32,f);
		break;
	case 28:
		var e20 = _g[2];
		f(e20);
		break;
	case 29:
		var e27 = _g[3];
		f(e27);
		break;
	}
}
ExprTools.map = function(e,f) {
	var e1 = e.pos;
	var _g = e.expr;
	var tmp;
	switch((Type().default).enumIndex(_g)) {
	case 0:
		tmp = e.expr;
		break;
	case 1:
		var e2 = _g[3];
		var e11 = _g[2];
		tmp = (haxe_macro_ExprDef().default).EArray(f(e11),f(e2));
		break;
	case 2:
		var e21 = _g[4];
		var e12 = _g[3];
		var op = _g[2];
		tmp = (haxe_macro_ExprDef().default).EBinop(op,f(e12),f(e21));
		break;
	case 3:
		var field = _g[3];
		var e3 = _g[2];
		tmp = (haxe_macro_ExprDef().default).EField(f(e3),field);
		break;
	case 4:
		var e4 = _g[2];
		tmp = (haxe_macro_ExprDef().default).EParenthesis(f(e4));
		break;
	case 5:
		var fields = _g[2];
		var ret = [];
		var _g1 = 0;
		while(_g1 < fields.length) {
			var field1 = fields[_g1];
			++_g1;
			ret.push({ field : field1.field, expr : f(field1.expr)});
		}
		tmp = (haxe_macro_ExprDef().default).EObjectDecl(ret);
		break;
	case 6:
		var el = _g[2];
		tmp = (haxe_macro_ExprDef().default).EArrayDecl((haxe_macro_ExprArrayTools().default).map(el,f));
		break;
	case 7:
		var params = _g[3];
		var e5 = _g[2];
		tmp = (haxe_macro_ExprDef().default).ECall(f(e5),(haxe_macro_ExprArrayTools().default).map(params,f));
		break;
	case 8:
		var params1 = _g[3];
		var tp = _g[2];
		tmp = (haxe_macro_ExprDef().default).ENew(tp,(haxe_macro_ExprArrayTools().default).map(params1,f));
		break;
	case 9:
		var e6 = _g[4];
		var postFix = _g[3];
		var op1 = _g[2];
		tmp = (haxe_macro_ExprDef().default).EUnop(op1,postFix,f(e6));
		break;
	case 10:
		var vars = _g[2];
		var ret1 = [];
		var _g2 = 0;
		while(_g2 < vars.length) {
			var v = vars[_g2];
			++_g2;
			ret1.push({ name : v.name, type : v.type, expr : ExprTools.opt(v.expr,f)});
		}
		tmp = (haxe_macro_ExprDef().default).EVars(ret1);
		break;
	case 11:
		var func = _g[3];
		var name = _g[2];
		var ret2 = [];
		var _g3 = 0;
		var _g11 = func.args;
		while(_g3 < _g11.length) {
			var arg = _g11[_g3];
			++_g3;
			ret2.push({ name : arg.name, opt : arg.opt, type : arg.type, value : ExprTools.opt(arg.value,f)});
		}
		tmp = (haxe_macro_ExprDef().default).EFunction(name,{ args : ret2, ret : func.ret, params : func.params, expr : f(func.expr)});
		break;
	case 12:
		var el1 = _g[2];
		tmp = (haxe_macro_ExprDef().default).EBlock((haxe_macro_ExprArrayTools().default).map(el1,f));
		break;
	case 13:
		var expr = _g[3];
		var it = _g[2];
		tmp = (haxe_macro_ExprDef().default).EFor(f(it),f(expr));
		break;
	case 14:
		var e22 = _g[3];
		var e13 = _g[2];
		tmp = (haxe_macro_ExprDef().default).EIn(f(e13),f(e22));
		break;
	case 15:
		var eelse = _g[4];
		var eif = _g[3];
		var econd = _g[2];
		tmp = (haxe_macro_ExprDef().default).EIf(f(econd),f(eif),ExprTools.opt(eelse,f));
		break;
	case 16:
		var normalWhile = _g[4];
		var e7 = _g[3];
		var econd1 = _g[2];
		tmp = (haxe_macro_ExprDef().default).EWhile(f(econd1),f(e7),normalWhile);
		break;
	case 17:
		var edef = _g[4];
		var cases = _g[3];
		var e8 = _g[2];
		var ret3 = [];
		var _g4 = 0;
		while(_g4 < cases.length) {
			var c = cases[_g4];
			++_g4;
			ret3.push({ expr : ExprTools.opt(c.expr,f), guard : ExprTools.opt(c.guard,f), values : (haxe_macro_ExprArrayTools().default).map(c.values,f)});
		}
		tmp = (haxe_macro_ExprDef().default).ESwitch(f(e8),ret3,edef == null || edef.expr == null ? edef : f(edef));
		break;
	case 18:
		var catches = _g[3];
		var e9 = _g[2];
		var ret4 = [];
		var _g5 = 0;
		while(_g5 < catches.length) {
			var c1 = catches[_g5];
			++_g5;
			ret4.push({ name : c1.name, type : c1.type, expr : f(c1.expr)});
		}
		tmp = (haxe_macro_ExprDef().default).ETry(f(e9),ret4);
		break;
	case 19:
		var e10 = _g[2];
		tmp = (haxe_macro_ExprDef().default).EReturn(ExprTools.opt(e10,f));
		break;
	case 20:case 21:case 26:
		tmp = e.expr;
		break;
	case 22:
		var e14 = _g[2];
		tmp = (haxe_macro_ExprDef().default).EUntyped(f(e14));
		break;
	case 23:
		var e15 = _g[2];
		tmp = (haxe_macro_ExprDef().default).EThrow(f(e15));
		break;
	case 24:
		var t = _g[3];
		var e16 = _g[2];
		tmp = (haxe_macro_ExprDef().default).ECast(f(e16),t);
		break;
	case 25:
		var isCall = _g[3];
		var e17 = _g[2];
		tmp = (haxe_macro_ExprDef().default).EDisplay(f(e17),isCall);
		break;
	case 27:
		var eelse1 = _g[4];
		var eif1 = _g[3];
		var econd2 = _g[2];
		tmp = (haxe_macro_ExprDef().default).ETernary(f(econd2),f(eif1),f(eelse1));
		break;
	case 28:
		var t1 = _g[3];
		var e18 = _g[2];
		tmp = (haxe_macro_ExprDef().default).ECheckType(f(e18),t1);
		break;
	case 29:
		var e19 = _g[3];
		var m = _g[2];
		tmp = (haxe_macro_ExprDef().default).EMeta(m,f(e19));
		break;
	}
	return { pos : e1, expr : tmp};
}
ExprTools.getValue = function(e) {
	var _g = e.expr;
	switch((Type().default).enumIndex(_g)) {
	case 0:
		switch((Type().default).enumIndex(_g[2])) {
		case 0:
			var v = _g[2][2];
			return (Std().default).parseInt(v);
		case 1:
			var v1 = _g[2][2];
			return (Std().default).parseFloat(v1);
		case 2:
			var s = _g[2][2];
			return s;
		case 3:
			switch(_g[2][2]) {
			case "false":
				return false;
			case "null":
				return null;
			case "true":
				return true;
			default:
				throw new (js__$Boot_HaxeError().default)("Unsupported expression: " + (Std().default).string(e));
			}
			break;
		default:
			throw new (js__$Boot_HaxeError().default)("Unsupported expression: " + (Std().default).string(e));
		}
		break;
	case 2:
		var e2 = _g[4];
		var e1 = _g[3];
		var op = _g[2];
		var e11 = ExprTools.getValue(e1);
		var e21 = ExprTools.getValue(e2);
		switch((Type().default).enumIndex(op)) {
		case 0:
			return e11 + e21;
		case 1:
			return e11 * e21;
		case 2:
			return e11 / e21;
		case 3:
			return e11 - e21;
		case 5:
			return e11 == e21;
		case 6:
			return e11 != e21;
		case 7:
			return e11 > e21;
		case 8:
			return e11 >= e21;
		case 9:
			return e11 < e21;
		case 10:
			return e11 <= e21;
		case 11:
			return e11 & e21;
		case 12:
			return e11 | e21;
		case 13:
			return e11 ^ e21;
		case 14:
			if(e11) {
				return e21;
			} else {
				return false;
			}
			break;
		case 15:
			if(!e11) {
				return e21;
			} else {
				return true;
			}
			break;
		case 16:
			return e11 << e21;
		case 17:
			return e11 >> e21;
		case 18:
			return e11 >>> e21;
		case 19:
			return e11 % e21;
		default:
			throw new (js__$Boot_HaxeError().default)("Unsupported expression: " + (Std().default).string(e));
		}
		break;
	case 4:
		var e12 = _g[2];
		return ExprTools.getValue(e12);
	case 5:
		var fields = _g[2];
		var obj = { };
		var _g1 = 0;
		while(_g1 < fields.length) {
			var field = fields[_g1];
			++_g1;
			(Reflect().default).setField(obj,field.field,ExprTools.getValue(field.expr));
		}
		return obj;
	case 6:
		var el = _g[2];
		return el.map(ExprTools.getValue);
	case 9:
		if(_g[3] == false) {
			var e13 = _g[4];
			var op1 = _g[2];
			var e14 = ExprTools.getValue(e13);
			switch((Type().default).enumIndex(op1)) {
			case 2:
				return !e14;
			case 3:
				return -e14;
			case 4:
				return ~e14;
			default:
				throw new (js__$Boot_HaxeError().default)("Unsupported expression: " + (Std().default).string(e));
			}
		} else {
			throw new (js__$Boot_HaxeError().default)("Unsupported expression: " + (Std().default).string(e));
		}
		break;
	case 15:
		var eelse = _g[4];
		var eif = _g[3];
		var econd = _g[2];
		if(eelse == null) {
			throw new (js__$Boot_HaxeError().default)("If statements only have a value if the else clause is defined");
		} else {
			var econd1 = ExprTools.getValue(econd);
			if(econd1) {
				return ExprTools.getValue(eif);
			} else {
				return ExprTools.getValue(eelse);
			}
		}
		break;
	case 22:
		var e15 = _g[2];
		return ExprTools.getValue(e15);
	case 27:
		var eelse1 = _g[4];
		var eif1 = _g[3];
		var econd2 = _g[2];
		if(eelse1 == null) {
			throw new (js__$Boot_HaxeError().default)("If statements only have a value if the else clause is defined");
		} else {
			var econd3 = ExprTools.getValue(econd2);
			if(econd3) {
				return ExprTools.getValue(eif1);
			} else {
				return ExprTools.getValue(eelse1);
			}
		}
		break;
	case 29:
		var e16 = _g[3];
		return ExprTools.getValue(e16);
	default:
		throw new (js__$Boot_HaxeError().default)("Unsupported expression: " + (Std().default).string(e));
	}
}
ExprTools.opt = function(e,f) {
	if(e == null) {
		return null;
	} else {
		return f(e);
	}
}
ExprTools.opt2 = function(e,f) {
	if(e != null) {
		f(e);
	}
}


// Export

exports.default = ExprTools;